<template>
  <div>
    <the-header header="Mes classes" />
    <div>
      <add-card-item
        @click.native="openModal('Ajouter une classe', 'create')"
        :image="'desk.svg'"
        class="my-5"
      />
      <div
        class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 xl:grid-cols-4 gap-8"
      >
        <div v-for="classe in classes" :key="classe.id">
          <mat-comp-sav-card-item-2
            :imageName="
              classe.typeEvaluations === 'cotes'
                ? 'evaluer.svg'
                : 'abc-block.svg'
            "
            :hideInfoClasse="false"
            :matCompSav="classe"
            @click.native="selectClasse(classe)"
            @onUpdateClick="openModal('Modifier une classe', 'update', classe)"
          />
        </div>
      </div>
    </div>
    <div>
      <modal-add-classe
        v-if="modalOpen"
        :data="dataToPassToModal"
        v-model="modalOpen"
        @closeRequest="modalOpen = false"
        @onModalSubmit="onModalSubmit"
        @onDeleteClasse="onDeleteClasse"
      />
    </div>
  </div>
</template>

<script>
import AddCardItem from "../components/AddCardItem.vue";
import MatCompSavCardItem2 from "../components/MatCompSavCardItem.vue";
import ModalAddClasse from "../components/modals/ModalAddClasse.vue";
import TheHeader from "../components/reusable/TheHeader.vue";
export default {
  components: { AddCardItem, ModalAddClasse, MatCompSavCardItem2, TheHeader },
  created() {
    this.$store.dispatch("bindClasses");
    this.$store.dispatch("bindAllEleves");
  },
  methods: {
    openModal(title, crud, classe = {}) {
      this.dataToPassToModal = { title, crud, classe };
      this.modalOpen = true;
    },
    onModalSubmit(classe) {
      this.$store.dispatch("addClasse", classe);
      this.modalOpen = false;
    },
    selectClasse(classe) {
      this.$router.push({
        path: "classes/" + classe.id + "/home",
      });
    },
    onDeleteClasse(classe) {
      this.$store.dispatch("deleteClasse", classe);
      this.modalOpen = false;
    },
  },
  computed: {
    classes() {
      return this.$store.state.classes;
    },
  },
  data() {
    return {
      modalOpen: false,
      dataToPassToModal: {},
    };
  },
};
</script>


